//----------------------------------------------------------------------------------
//		AviSynthTCPDeliverT[o(o̓vOC)  for AviUtl ver0.99
//----------------------------------------------------------------------------------
#include <windows.h>

#include "output.h"
#include "resource.h"
#include "yuy2fc_client.h"

//---------------------------------------------------------------------
//		o̓vOC\̒`
//---------------------------------------------------------------------
OUTPUT_PLUGIN_TABLE output_plugin_table = {
	NULL,												//	tO
	"AVSDeliverServer",									//	vOC̖O
	"AviFile (*.avi)\0*.avi\0",							//	o̓t@C̃tB^
	"AviSynth TCPDeliverT[o version 0.01 By MZH",	//	vOC̏
	NULL,												//	DLLJnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,												//	DLLIɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_output,										//	o͎ɌĂ΂֐ւ̃|C^
	func_config,										//	o͐ݒ̃_CAOvꂽɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_config_get,									//	o͐ݒf[^擾鎞ɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_config_set,									//	o͐ݒf[^ݒ肷鎞ɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
};


//---------------------------------------------------------------------
//		o̓vOC\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C OUTPUT_PLUGIN_TABLE __declspec( dllexport) * __stdcall GetOutputPluginTable( void)
{
	return &output_plugin_table;
}

//---------------------------------------------------------------------
//		o̓vOCϐ
//---------------------------------------------------------------------
typedef struct {
	TCHAR	name[256];
	UINT	interlace;
	UINT	topfirst;
} CONFIG;
static CONFIG	config = {"22050", BST_CHECKED, BST_CHECKED};

// Mf[^wb_
struct cmdbuf {
	int len;
	char cmd;
};
struct videoinf {
	int x,y,fps1,fps2,frames,format;
	int a_rate,a_type,a_nl,a_nh,a_ch;
	int interlace;
};
struct videoframe { 
	int framenum,uvline,other1,uvhight,other2;
	int uvline2,other3,uvframebytes;
	int compress,uvframebytes2;
	int other4,other5,other6,other7,other8,other9,other10;
};
struct audioframe {
	int bytes1,compress,bytes2;
	int other1,other2,other3,other4,other5;
};
#define formatYUY2 0x60000004;
#define formatRGB24 0x50000001;
int sendblock( int sock, char *buf, int size);

BOOL func_output( OUTPUT_INFO *oip)
{
	WSADATA wsadata;
    struct sockaddr_in sin, from;
    struct hostent *hp;
    struct servent *sp;
	int port;
    int s,sn;
    int fromlen;
	fd_set recv_set;
	timeval to;
	int ret;
	struct cmdbuf cmdbuf;
	char recvbuf[ 1024];
	struct videoinf videoinfbuf;
	struct videoframe videoframebuf;
	void *pixelp;
	int framenum;
	int framebytes;
	int yuy2_size;
	int isYUY2;
    int rt;
	int datlen,cmd,rcvsize;
	int audio_s,audio_c,audiobytes;
	struct audioframe audioframebuf;
	void *audiop;
	int audiosamples;

	ret = WSAStartup( 0x02, &wsadata);
	if( ret){
		return FALSE;
	}

    sp = getservbyname( config.name, "tcp");
    if(!sp){
		port = htons( atoi( config.name));
    }else{
		port = sp->s_port;
	}
    s = socket( AF_INET, SOCK_STREAM, 0);
    if( s < 0 ){
        return FALSE;
    }
    hp = gethostbyname( "localhost");
    if( !hp){
	goto goout;
    }

    memcpy( (char *)&sin.sin_addr, hp->h_addr_list[ 0 ], hp->h_length);
    sin.sin_family = AF_INET;
	sin.sin_addr.s_addr = INADDR_ANY;
    sin.sin_port = port;
    if( bind( s, (struct sockaddr *)&sin, sizeof( sin)) < 0){
	goto goout;
    }
    if( listen( s, 5) < 0){
	goto goout;
    }
	// ڑ҂
    fromlen = sizeof( from );
	to.tv_sec = 0;
	to.tv_usec = 0;
	while( 1){
		if(oip->func_is_abort())
			goto goout;
		FD_ZERO( &recv_set);
		FD_SET( s, &recv_set);
		select( 0, &recv_set, NULL, NULL, &to);
		if( FD_ISSET( s, &recv_set)){
		    sn = accept( s, (struct sockaddr *)&from, &fromlen);
		    if( sn < 0 ){
			    goto goout;
			}
			break;
		}
		Sleep( 100);
	}
    closesocket( s);
	__asm{emms}

    while( 1) {
		// oCg
		while( 1){
			if(oip->func_is_abort())
				goto loopout;
			FD_ZERO( &recv_set);
			FD_SET( sn, &recv_set);
			to.tv_sec = 0;
			to.tv_usec = 10000;
			select( 0, &recv_set, NULL, NULL, &to);
			if( FD_ISSET( sn, &recv_set)){
				// oCg
				rt = recv( sn, recvbuf, 4, 0);
				if(rt <= 0) {
					goto loopout;
				}
				break;
			}
		}
		datlen = *(int *)recvbuf - 1;
		// R}h
		rt = recv( sn, recvbuf, 1, 0);
		if( rt <= 0) {
			goto loopout;
		}
		cmd = *(char *)recvbuf;
		// f[^TCYǂݍ
		// 1Kȏ͖
		while( datlen > 0){
			if( datlen <= 1024)
				rcvsize = datlen;
			else
				rcvsize = 1024;
			rt = recv( sn, recvbuf, datlen, 0);
			if( rt <= 0) {
				goto loopout;
			}
			datlen -= rt;
		}
		if( cmd == 4){
			// ؒf
			break;
		}else
		if( cmd == 7){
			// o[W
			cmdbuf.len = 1;
			cmdbuf.cmd = 0x06;
			if( sendblock( sn, (char *)&cmdbuf, 5) <= 0) {
				goto loopout;
			}
		}else
		if( cmd == 0x16){
			// rfI
			cmdbuf.len = sizeof( struct videoinf) + 1;
			cmdbuf.cmd = 0x1e;
			if( sendblock( sn, (char *)&cmdbuf, 5) <= 0) {
				goto loopout;
			}
			if( oip->flag & OUTPUT_INFO_FLAG_VIDEO){
				// rfI
				// YUY2t[LbV邩`FbN
				pixelp = oip->func_get_video( 0);
				pixelp = yuy2fc_get_cache( 0, oip->w, oip->h, &yuy2_size);
				if( pixelp == NULL)
					isYUY2 = FALSE;
				else
					isYUY2 = TRUE;
				// ̑rfI
				videoinfbuf.x = oip->w;
				videoinfbuf.y = oip->h;
				videoinfbuf.fps1 = oip->rate;
				videoinfbuf.fps2 = oip->scale;
				videoinfbuf.frames = oip->n;
				if( isYUY2){
					videoinfbuf.format = formatYUY2;
				}else{
					videoinfbuf.format = formatRGB24;
				}
				if( config.interlace){
					if( config.topfirst)
						videoinfbuf.interlace = 6; //1=BFF,2=TFF,4=interlace
					else
						videoinfbuf.interlace = 5;
				}else
					videoinfbuf.interlace = 0;
			}else{
				// rfIȂ
				videoinfbuf.x = 0;
			}
			if( oip->flag & OUTPUT_INFO_FLAG_AUDIO){
				// I[fBI
				videoinfbuf.a_rate = oip->audio_rate;
				videoinfbuf.a_type = 0x02; //2=PCM16
				videoinfbuf.a_nl = oip->audio_n;
				videoinfbuf.a_nh = 0;
				videoinfbuf.a_ch = oip->audio_ch;
			}else{
				// I[fBIȂ
				videoinfbuf.a_rate = 0;
			}
			// 𑗂
			if( sendblock( sn, (char *)&videoinfbuf, sizeof( struct videoinf)) <= 0) {
				goto loopout;
			}
		}else
		if( cmd == 0x0a){
			// rfIt[
			framenum = *(int *)recvbuf;
			if( isYUY2){
				pixelp = yuy2fc_get_cache( framenum, oip->w, oip->h, &yuy2_size);
				if( pixelp == NULL){
					// LbVɂȂƂtB^
					oip->func_rest_time_disp( framenum, oip->n);
					pixelp = oip->func_get_video( framenum);
					oip->func_update_preview();
					pixelp = yuy2fc_get_cache( framenum, oip->w, oip->h, &yuy2_size);
					if( pixelp == NULL)
						goto loopout;
				}
				framebytes = yuy2_size;
			}else{
				// RGB̂Ƃ
				oip->func_rest_time_disp( framenum, oip->n);
				pixelp = oip->func_get_video( framenum);
				framebytes = oip->size;
				oip->func_update_preview();
			}

			// t[wb_̏
			videoframebuf.framenum = framenum;
			if( isYUY2){
				videoframebuf.uvline = oip->w*2;
				videoframebuf.uvline2 = oip->w*2;
			}else{
				videoframebuf.uvline = oip->w*3;
				videoframebuf.uvline2 = oip->w*3;
			}
			videoframebuf.uvhight = oip->h;
			videoframebuf.uvframebytes = framebytes;
			videoframebuf.uvframebytes2 = framebytes;
			videoframebuf.compress = 0; // 0=NONE
			// oCgƃR}h
			cmdbuf.len = framebytes + sizeof( struct videoframe) + 1;
			cmdbuf.cmd = 0x1f;
			if( sendblock( sn, (char *)&cmdbuf, 5) <= 0){
				goto loopout;
			}
			if( sendblock( sn, (char *)&videoframebuf, sizeof( struct videoframe)) <= 0){
				goto loopout;
			}
			// t[M
			if( sendblock( sn, (char *)pixelp, framebytes) <= 0){
				goto loopout;
			}
		}else
		if( cmd == 0x0b){
			// I[fBIt[
			audio_s = *(int *)&recvbuf[ 0];
			audio_c = *(int *)&recvbuf[ 8];
			audiobytes = *(int *)&recvbuf[ 16];
//			audio_c = audiobytes/oip->audio_size;
			audiop = oip->func_get_audio( audio_s, audio_c, &audiosamples);
//			audiobytes = audiosamples * oip->audio_size;
			cmdbuf.len = audiobytes + sizeof( struct audioframe) + 1;
			cmdbuf.cmd = 0x20;
			if( send( sn, (char *)&cmdbuf, 5, 0) != 5){
				goto loopout;
			}
			// I[fBIwb_
			audioframebuf.bytes1 = audiobytes;
			audioframebuf.bytes2 = audiobytes;
			audioframebuf.compress = 0; // 0=NONE
//			audioframebuf.other1 = audiosamples;
//			audioframebuf.other2 = oip->audio_size;
//			audioframebuf.other3 = oip->audio_n;
//			audioframebuf.other4 = oip->audio_rate;
			if( sendblock( sn, (char *)&audioframebuf, sizeof( struct audioframe)) <= 0){
				goto loopout;
			}
			// I[fBIt[M
			if( sendblock( sn, (char *)audiop, audiobytes) <= 0){
				goto loopout;
			}
		}
    }
loopout:
    closesocket( sn);
	WSACleanup();
	return TRUE;
goout:
	closesocket( s);
	WSACleanup();
	return TRUE;
}

// 64K؂đM
int sendblock( int sock, char *buf, int size)
{
	int sent=0, rt=0, sendbytes, i;

	for( i=0; i< size; i+=rt){
		if( size-i < 64*1024)
			sendbytes = size-i;
		else
			sendbytes = 64*1024;
		rt = send( sock, &buf[ i], sendbytes, 0);
		if( rt <= 0)
			return sent;
		sent += rt;
	}
	return sent;
}

//---------------------------------------------------------------------
//		o̓vOCݒ֐
//---------------------------------------------------------------------
LRESULT CALLBACK func_config_proc( HWND hdlg, UINT umsg, WPARAM wparam, LPARAM lparam )
{
	switch( umsg) {
		case WM_INITDIALOG:
			SetDlgItemText( hdlg, IDC_EDIT0, config.name);
			CheckDlgButton( hdlg, IDC_CHECK1, config.interlace);
			CheckDlgButton( hdlg, IDC_CHECK2, config.topfirst);
			return TRUE;
		case WM_COMMAND:
			switch( LOWORD( wparam) ) {
				case IDCANCEL:
					EndDialog( hdlg, LOWORD( wparam));
					break;
				case IDOK:
					GetDlgItemText( hdlg, IDC_EDIT0, config.name, sizeof( config.name));
					config.interlace = IsDlgButtonChecked( hdlg, IDC_CHECK1);
					config.topfirst = IsDlgButtonChecked( hdlg, IDC_CHECK2);
					EndDialog( hdlg, LOWORD( wparam));
					break;
			}
			break;
	}
	return FALSE;
}

BOOL func_config( HWND hwnd, HINSTANCE dll_hinst)
{
	DialogBox( dll_hinst, "CONFIG", hwnd, (DLGPROC)func_config_proc);
	return TRUE;
}

int func_config_get( void *data,int size)
{
	if( data ) memcpy( data, &config, sizeof( config));
	return sizeof( config);
}

int func_config_set( void *data,int size)
{
	if( size != sizeof( config)) return NULL;
	memcpy( &config, data, size);
	return size;
}
